#include "mview.h"
#include <stdio.h>
#include <stdlib.h>
#include <doslib.h>
#include <iocslib.h>
#include <string.h>
#include	"dir.h"
#include "sub.h"
#include "mail.h"
#include "console.h"
#include "mime.h"
#include "func.h"
#include	"address.h"

extern void	GetEnvRc(char *progpath);

static void	DirWin();
static void	MainCont(void);
static int	AddressInit();


void	main(int argc, char *argv[])
{
	initdisp();

	Env.pack = NULL;
	MailNow = 0;
	Mail = NULL;
	MailOn = NULL;

	DirFlag = 0;
	Dir = 0;

	GetEnvRc(argv[0]);
	strcpy(CDir, Env.Mailbox);

	AddressInit();

	PutScreen = listredraw;

	while (1) {
		StatusPut(NULL);
		/* fBNgTAȂ΃t@CT */
		if (DIRGET(CDir, TRUE)) {
			DirFlag = FALSE;
			DIRSET();
			DirWin();
		} else {
			DirFlag = TRUE;
			FILEGET();

			SaveFlag = FALSE;

			if (MailNow) {
				MainCont();
			} else {
				/* fBNgɃt@CȂΖ߂ */
				CDirPre();
				Dir--;
			}
		}
	}
}

void	DirWin()
{
	unsigned char	Key;

	PutScreen();

	while (1) {
		MKEY_WAIT();
		Key = MKEY_GET();

		switch (Key) {
		case KEYUP:
		case KEYP+KEYCTRL:
		case KEYE+KEYCTRL:
			if (TargetNum) {	/* uv */
				if (PutNum) {	/* \J[\݂̂炷 */
					ColorWPut(PutNum - 1, TargetNum - 1);
					ColorNPut(PutNum--, TargetNum--);
				} else {
					tscroll(1);
					StartNum--;
					ColorWPut(PutNum, TargetNum - 1);
					ColorNPut(PutNum + 1, TargetNum--);
				}
			}
			break;

		case KEYDOWN:
		case KEYN+KEYCTRL:
		case KEYX+KEYCTRL:
			if (TargetNum < MailNow - 1) {	/* uv */
				if (PutNum != PAGEROW - 1) {	/* \J[\݂̂炷 */
					ColorWPut(PutNum + 1, TargetNum + 1);
					ColorNPut(PutNum++, TargetNum++);
				} else { /* XN[ */
					tscroll(0);
					StartNum++;
					ColorWPut(PutNum, TargetNum + 1);
					ColorNPut(PutNum - 1, TargetNum++);
				}
			}
			break;

		case KEYROLLDOWN:	/* uROLL DOWNv */
		case KEYZ+KEYCTRL:
		case KEYR+KEYCTRL:
							/* Py[Wړ */
			StartNum -= PAGEROW - 1;
			 /* \[n[ƈv */
			if (StartNum < 0)	StartNum = 0;
			TargetNum -= PAGEROW - 1;
			if (TargetNum < 0)	TargetNum = 0;

			PutScreen();
			break;

		case KEYROLLUP:		/* uROLL UPv */
		case KEYV+KEYCTRL:
		case KEYC+KEYCTRL:
			StartNum += PAGEROW - 1;	/* Py[Wړ */
			if (StartNum + PAGEROW - 1 >= MailNow) {
				/* Eяo␳ */
				StartNum = MailNow - PAGEROW;
				if (StartNum < 0)	StartNum = 0;
			}
			TargetNum += PAGEROW - 1;
			if (TargetNum >= MailNow) {
				TargetNum = MailNow - 1;
			}
			PutScreen();
			break;

		case KEYRIGHT:
		case KEYRETURN:		/* uEv */
		case KEYF+KEYCTRL:
		case KEYD+KEYCTRL:
		case KEYM+KEYCTRL:
			/* fBNgύX */
			if (!(SendFlag = SendCheck(Mail[TargetNum].title))) {
				TrashFlag = !strcmpi(Mail[TargetNum].title, "TRASH")? 1:0;
			}

			strcat(CDir, Mail[TargetNum].title);
			PlusSlash(CDir);
			Dir++;
			return;

		case KEYLEFT:		/* uv */
		case KEYBS:
		case KEYUNDO:
		case KEYU+KEYCTRL:
		case KEYB+KEYCTRL:
		case KEYS+KEYCTRL:
		case KEYH+KEYCTRL:
			if (Dir) {	/* fBNgǂ */
				CDirPre();
				Dir--;
				SendFlag = 0;
				return;
			}
			break;

		case KEYW:			/* Vȃ[̍쐬 */
			WriteMail(NULL, NULL);
			break;

		case KEYR+KEYSHIFT:	/* [M */
			receive();
			break;

		case KEYHOME:
		case KEYCM+KEYSHIFT:
		case KEYG:
			if (TargetNum) {
				TargetNum = 0;	/* 擪 */
				StartNum = 0;
				PutScreen();
			}
			break;

		case KEYHOME+KEYSHIFT:
		case KEYPR+KEYSHIFT:
		case KEYG+KEYSHIFT:
			if (TargetNum < MailNow - 1) {
				TargetNum = MailNow - 1;	/*  */
				StartNum = MailNow - PAGEROW;
				if (StartNum < 0)	StartNum = 0;
				PutScreen();
			}
			break;

		case KEYESC:		/* I */
		case KEYKK+KEYCTRL:
		case KEYQ:
			quitop(NULL);
			break;
		}
	}
}

/* 샋[` */
void	MainCont(void)
{
	unsigned char	Key;

	PutScreen();

	while (1) {
		MKEY_WAIT();
		Key = MKEY_GET();

		switch (Key) {
		case KEYH+KEYCTRL:	/* J[\߂ă}[N */
			if (TargetNum && MailOn[TargetNum - 1]) {
				MarkNum--;
				MailOn[TargetNum - 1] = FALSE;
			}

		case KEYUP:
		case KEYP+KEYCTRL:
		case KEYE+KEYCTRL:
			if (TargetNum) {	/* uv */
				if (PutNum) {	/* \J[\݂̂炷 */
					ColorWPut(PutNum - 1, TargetNum - 1);
					ColorNPut(PutNum--, TargetNum--);
				} else {
					tscroll(1);
					StartNum--;
					ColorWPut(PutNum, TargetNum - 1);
					ColorNPut(PutNum + 1, TargetNum--);
				}
			}
			break;

		case KEYTAB:
		case KEYSPACE:	/* }[N̂͂ */
			if (MailOn[TargetNum]) {
				MarkNum--;
				MailOn[TargetNum] = FALSE;
			} else {
				MarkNum++;
				MailOn[TargetNum] = TRUE;
			}
/*			ColorWPut(PutNum, TargetNum);
			break;*/

		case KEYDOWN:
		case KEYN+KEYCTRL:
		case KEYX+KEYCTRL:
			if (TargetNum < MailNow - 1) {	/* uv */
				if (PutNum != PAGEROW - 1) {	/* \J[\݂̂炷 */
					ColorWPut(PutNum + 1, TargetNum + 1);
					ColorNPut(PutNum++, TargetNum++);
				} else { /* XN[ */
					tscroll(0);
					StartNum++;
					ColorWPut(PutNum, TargetNum + 1);
					ColorNPut(PutNum - 1, TargetNum++);
				}
			} else {
				ColorPut(PutNum, TargetNum, TRUE);
			}
			break;

		case KEYROLLDOWN:	/* uROLL DOWNv */
		case KEYZ+KEYCTRL:
		case KEYR+KEYCTRL:
							/* Py[Wړ */
			StartNum -= PAGEROW - 1;
			 /* \[n[ƈv */
			if (StartNum < 0)	StartNum = 0;
			TargetNum -= PAGEROW - 1;
			if (TargetNum < 0)	TargetNum = 0;

			PutScreen();
			break;

		case KEYROLLUP:		/* uROLL UPv */
		case KEYV+KEYCTRL:
		case KEYC+KEYCTRL:
			StartNum += PAGEROW - 1;	/* Py[Wړ */
			if (StartNum + PAGEROW - 1 >= MailNow) {
				/* Eяo␳ */
				StartNum = MailNow - PAGEROW;
				if (StartNum < 0)	StartNum = 0;
			}
			TargetNum += PAGEROW - 1;
			if (TargetNum >= MailNow) {
				TargetNum = MailNow - 1;
			}
			PutScreen();
			break;

		case KEYRIGHT:
		case KEYRETURN:		/* uEv */
		case KEYF+KEYCTRL:
		case KEYD+KEYCTRL:
		case KEYM+KEYCTRL:
			MailView();	/* r[AN */
			break;

		case KEYLEFT:		/* uv */
		case KEYBS:
		case KEYUNDO:
		case KEYU+KEYCTRL:
		case KEYB+KEYCTRL:
		case KEYS+KEYCTRL:
			if (Dir) {	/* fBNgǂ */

				/* ǏȂǂ̕ۑ -- fBNg͎sȂ */
				SaveInf();

				CDirPre();
				Dir--;
				SendFlag = 0;
				return;
			}
			break;

		case KEYHOME:
		case KEYCM+KEYSHIFT:
		case KEYG:
			if (TargetNum) {
				TargetNum = 0;	/* 擪 */
				StartNum = 0;
				PutScreen();
			}
			break;

		case KEYHOME+KEYSHIFT:
		case KEYPR+KEYSHIFT:
		case KEYG+KEYSHIFT:
			if (TargetNum < MailNow - 1) {
				TargetNum = MailNow - 1;	/*  */
				StartNum = MailNow - PAGEROW;
				if (StartNum < 0)	StartNum = 0;
				PutScreen();
			}
			break;

		case KEYW:			/* Vȃ[̍쐬 */
			WriteMail(NULL, NULL);
			break;

		case KEYF+KEYSHIFT:
			WriteMail(&(Mail[TargetNum]), CDir);
			break;

		case KEYCLR:		/* }[N̑S */
		case KEYA:
			AllMark();
			break;

		case KEYESC:		/* I */
		case KEYKK+KEYCTRL:
		case KEYQ:
			quitop(NULL);
			break;

		/* ȉ̓fBNgł͕s */
		case KEYS:
			if (SendFlag) {	/* M */
				if (!MarkNum) { /* }[NȂΕt */
					MarkNum++;
					MailOn[TargetNum] = TRUE;
				}
				if (NormalSent())	return;
			}
			break;

		case KEYS+KEYSHIFT:
			if (SendFlag == 2 && !MarkNum) { /* ꊇM */
				AllSent();
				if (NormalSent())	return;
			}
			break;

		case KEYE:
			if (SendFlag == 2)	MailEdit();
			break;

		case KEYX:		/* Yt@\ */
			if (SendFlag && !(Mail[TargetNum].fileflag & M_CLIP)) {
				MimeClip();
			}
			break;

		case KEYX+KEYSHIFT:	/* Ytt@CWJ@\ */
			MimeExtract(&(Mail[TargetNum]), CDir);
			break;

		case KEYF:
		case KEYR:		/* XԂ */
			ResMail();
			break;

		case KEYTAB+KEYSHIFT:	/* \̐؂ւ */
			Env.FilePutFlag = !Env.FilePutFlag;
			PutScreen();
			break;

		case KEYM:
			if (MailMove())	return;
			break;

		case KEYM+KEYSHIFT:
			if (AutoMove())	return;
			break;

		case KEYK:
		case KEYD:
		case KEYDEL:
			if (MailKill())	return;
			break;

		case KEYC:	/* [ʖۑ */
			copymail(&(Mail[TargetNum]), CDir);
			break;

		case KEYR+KEYSHIFT:	/* [M */
			receive();
			break;

		case KEYZ:
			if (Dir) { /* ǁAɂ */
				int	i;

				for (i = 0 ; i <= TargetNum; i++) {
					if (!(Mail[i].fileflag & M_CHECK)) {
						Mail[i].fileflag |= M_CHECK;
						SaveFlag = TRUE;
					}
				}
				PutScreen();
			}
			break;
		}
	}
}


int
AddressAdd(mail)
MAILDATA	*mail;
{
	FILE	*fp;
	char	*ptr = NULL, file[FILNMAX], temp[BUFMAX];

	strcpy(file, CDir);
	strcat(file, mail->filename);
	if (!(fp = fopen(file, "rt"))) {	/* BI */
		sprintf(temp, "[ %s ǂ߂܂", file);
		StatusPut(temp);
		return FALSE;
	}

	/* AhX֌WTBsŏI */
	while (fgets822a(temp, sizeof(temp), fp)) {
		decode_mime(temp, temp);
		if (ptr = GetKeyword(temp, "FROM:")) {	/* From 擾 */
			char	*tmp2;

		/* From: ɂ <>^A()^AOL^B
			𔻕ʂAhX擾 */

			if (tmp2 = strchr(ptr, '<')) {
				ptr = ++tmp2;
				while (*tmp2 && *tmp2 != '>')	tmp2++;
				*tmp2 = '\0';
			} else if (tmp2 = strchr(ptr, '(')) {
				/* AhX̌ɋ󔒂̂h */
				if (*(tmp2 - 1) == ' ')	tmp2--;
				*tmp2 = '\0';
			}
			break;
		}
	}
	fclose(fp);

	if (!ptr) {
		sprintf(temp, "%s ɃAhX܂", mail->title);
		StatusPut(temp);
		return FALSE;
	}

	strcpy(file, Env.Mailbox);
	strcat(file, "ADRESS.TXT");
	if (!(fp= fopen( file, "at"))) {
		StatusPut("AhXJ܂");
		return FALSE;
	}
	fprintf(fp, "%s\t%s\n", mail->name, ptr);
	fclose(fp);

	sprintf(temp, "%s AhXɓo^܂", mail->name);
	StatusPut(temp);

	if (abook.Address) {
		free(abook.Address);
		abook.Address = NULL;
	}
	return AddressInit();
}

static int
AddressMemInit(book)
ADDRESSBOOK	*book;
{
	book->Address = malloc(sizeof(ADDRESS) * book->Max);
	if (!book->Address) {
		book->Address = NULL;
		book->Max = 0;
		book->Now = 0;
		StatusPut("AhXpmۂł܂");
		return FALSE;
	}
	return TRUE;
}

/* AhXǂݍ */
static int
AddressInit()
{
	FILE	*fp;
	char	*TempP, endflag = FALSE;
	char	Temp[256];

	abook.Max = ADDRESS_MAX;

	while (!endflag) {
		abook.Now = 1;
		if (!AddressMemInit(&abook))	return FALSE;
		strcpy(abook.Address[0].name, "AhXgȂ");
		abook.Address[0].address = NULL;

		strcpy(Temp, Env.Mailbox);
		strcat(Temp, "ADRESS.TXT");
		fp = fopen(Temp, "rt");
		if (!fp)	return TRUE;

		while (1) {
			if (!fgets(Temp, 128, fp)) {
				endflag = TRUE;
				break;
			}
			if (abook.Now >= abook.Max) {
				if (abook.Address) {
					free(abook.Address);
					abook.Address = NULL;
				}
				abook.Max *= 2;
				break;
			}
			/* ܂O擾 */
			TempP = strcpy(abook.Address[abook.Now].name, Temp);
			TempP = strchr(TempP, '\t');	/* AhX̓o */
			*TempP++ = '\0';
			abook.Address[abook.Now++].address = TempP;
			TempP = strchr(TempP, '\n');	/* sR[h΂ */
			*TempP = '\0';					/* łP擾 */
		}
		fclose(fp);
		realloc(abook.Address, sizeof(ADDRESS) * abook.Now);
	}
	return TRUE;
}

void	quitop(char* mes)
{
						/* INF̕ۑiǕۑړIj */
	if (DirFlag)	SaveInf();

						/* ̉ */
	if (Mail) {
		free(Mail);
		Mail = NULL;
	}
	if (MailOn) {
		free(MailOn);
		MailOn = NULL;
	}
	if (abook.Address) {
		free(abook.Address);
		abook.Address = NULL;
	}
	if (Env.pack) {
		free(Env.pack);
		Env.pack = NULL;
	}

	B_CLR_AL();
	C_FNKMOD(0);
	KFLUSHIO(0xff);		/* L[͂̂Ă */

	if (mes) {
		fputs(mes, stderr);
		exit(1);
	} else {
		exit(0);
	}
}

