* mview.x
* assembler sub routine

	.include iocscall.mac

R21	equ	$e8002a
TRAM	equ	$e00000
VDISP	equ	$e88001

	.text

*hacked for mview.x

*=====================================================================
*
*	B_PUTC, B_PRINT handle routine for micorEMACS J1.40
*				      icam/Hommy + PEACE/SALT version
*
*			1990/10/25 written by SALT
*
*=====================================================================

		xdef		_intercept
		xdef		_intercept_end

*---------------------------------------------------------------------

FLUSH_COUNT	equ		50

*---------------------------------------------------------------------
*
*
*
*

_intercept:

		link		a6,#0

		pea		_b_keysns(pc)
		move.w		#$101,-(sp)		* B_KEYSNS
		dc.w		$ff25
		move.l		d0,old_b_keysns

		addq.w		#6,sp

		move.l		#FLUSH_COUNT,flush_count
		clr.w		disable_flag
		IOCS	__ONTIME
		move.l	d0,oldtime

		unlk		a6
		rts


*
*
*	void	intercept_end(void)
*
*

_intercept_end:

		move.l		old_b_keysns,-(sp)
		move.w		#$101,-(sp)		* B_KEYSNS
		dc.w		$ff25			* INTVCS

		addq.w		#6,sp
		rts

*
*
*	_b_keysns
*
*

_b_keysns:
		movem.l	d0-d2/a0-a2,-(sp)
		tst.w		disable_flag
		bne		_b_keysns_end

		IOCS	__ONTIME
		sub.l	oldtime(OPC),d0
		bmi	@f
		cmp.l	flush_count(OPC),d0
		blt		_b_keysns_end
@@
		addq.w		#1,disable_flag
		moveq.l	#-1,d0
		move.l	d0,-(sp)
		bsr		_putcursor
		addq.w	#4,sp
		subq.w		#1,disable_flag

_b_keysns_end
		movem.l	(sp)+,d0-d2/a0-a2
		move.l		old_b_keysns(OPC),-(sp)
		rts

*---------------------------------------------------------------------

disable_flag	.ds.w		1
flush_count	.ds.l		1
oldtime		.ds.l		1

old_b_keysns	.ds.l		1

x		.ds.l	1
y		.ds.l	1
len		.ds.l	1

*=====================================================================

	.even
	.global	_putcursor
_putcursor:
	move.l	4(sp),d0	*xpos
	bpl	newpos

	move.l	x(OPC),d0
	move.l	y(OPC),d1
	move.l	len(OPC),d2
	bra	gotpos
newpos:
	movem.l	8(sp),d1/d2	*ypos, len
	move.l	d0,x
	move.l	d1,y
	move.l	d2,len
gotpos:
	swap.w	d1
	lsr.l	#5,d1
	add.w	d0,d1		*skip x
	lea.l	TRAM,a0		*text vram top
	adda.l	d1,a0

	suba.l	a1,a1
	IOCS	__B_SUPER
	movea.l	d0,a1		*ssp

	lea.l	R21,a2
	move.w	(a2),d0		*R21 : text access/graphic clr
	move.w	#%0001_0011_0000,(a2)

	bra	bcursor_ent
@@
	.irp	%L,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15
	not.b	128*%L(a0)
	.endm

	addq.w	#1,a0
bcursor_ent:
	dbra	d2,@b
end_cursor:
	move.w	d0,(a2)
	move.l	a1,d0
	bmi	@f
	IOCS	__B_SUPER
@@
	IOCS	__ONTIME
	move.l	d0,oldtime
	rts

	.even
	.end
