* decode quoted_printable line
*
* this source is 'free' and 'not guaranteed'
* 10, Jan, 2000 Rick <shonma@geocities.co.jp>
*
* (usege)
*	int decqenc(char *dest, char *src)
*
* (arguments)
*	dest ... pointer to destination buffer
*	src  ... pointer to source buffer
*
* (return value)
*	number of decoded characters
*	-1   ... error. bad character exists

*	NO_APP

	.cpu	68000

*	X68	GCC	Develop

LF	equ	$0a
TAB	equ	$09

	.even
	.text

	.even
	.globl	_decqenc
_decqenc:
	movem.l	4(sp),a0/a1	*w = dest, r = src
	lea	-1(a0),a2	*last = dest - 1
	moveq.l	#9,d2
	bra	loop_ent
loop:
	cmpi.b	#'=',d1
	bne	normalchr

	move.b	(a1)+,d1	*high code
	cmpi.b	#' ',d1		*isspace
	beq	softbreak

	sub.b	d2,d1
	cmpi.b	#4,d1
	bls	softbreak

	addi.b	#TAB-'0',d1
	cmp.b	d2,d1		*isdigit
	bls	lowcode

	addi.b	#'0'-'A',d1
	andi.b	#$df,d1		*toupper
	cmpi.b	#5,d1		*isxdigit
	bhi	badcode

	addi.b	#10,d1
lowcode:
	move.b	(a1)+,d0	*low code
	subi.b	#'0',d0
	cmp.b	d2,d0		*isdigit
	bls	gotcode

	addi.b	#'0'-'A',d0
	andi.b	#$df,d0		*toupper
	cmpi.b	#5,d0		*isxdigit
	bhi	badcode

	addi.b	#10,d0
gotcode:
	lsl.b	#4,d1
	or.b	d0,d1
	movea.l	a0,a2		*last = w
normalchr:
	move.b	d1,(a0)+
loop_ent:
	move.b	(a1)+,d1
	bne	loop

	sf.b	d1
delspc:
	subq.w	#1,a0		*--w
	cmpa.l	a2,a0		*last >= w ?
	bls	delspc_break

	move.b	(a0),d0
	cmpi.b	#' ',d0		*isspace
	beq	delspc

	cmpi.b	#LF,d0		*isspace
	bne	@f

	st.b	d1
	bra	delspc
@@
	sub.b	d2,d0
	cmpi.b	#4,d0
	bls	delspc
delspc_break:
	addq.w	#1,a0
	tst.b	d1
	beq	softbreak

	move.b	#LF,(a0)+
softbreak:
	clr.b	(a0)
	move.l	a0,d0
	sub.l	4(sp),d0	*w - dest
	rts
badcode:
	moveq.l	#-1,d0
	rts

	.even
	.end
