#ifndef	__stdio_h__
#include	<stdio.h>
#endif

#ifndef TRUE
#define	TRUE	1
#endif

#ifndef FALSE
#define	FALSE	0
#endif

typedef struct {
	char	*bs;
	char	*be;
	int	(*decoder)(char*, char*);
	char	*(*converter)(char*, char*);
} MIMEMACHINE;

extern char	JIS_HEADER[];
extern char	EUC_HEADER[];
extern char	SJIS_HEADER[];
extern char	CHARSET_HEADER[];

/* decode_mime.c */
char	*decode_mime(char *dest, char *src);

/* decbenc.s */
int	decbenc(char *dest, char *src);

/* decqenc.s */
int	decqenc(char *dest, char *src);

/* jis2sjis.s */
char	*jis2sjis(char *dest, char *src);

/* euc2sjis.s */
char	*euc2sjis(char *dest, char *src);

/* assub.s */
int	headicmp(char *str, char *key);

/* mail.c */
void MakeViewFile(FILE *wfp, char *head);
void ResMail ( void );
void WriteMail(MAILDATA *mail, char *dir);

/* mailinf.c */
void MakeInf ( void );
void SaveInf ( void );
void RemoveInf ( void );
