#include "mview.h"
#include <stdio.h>
#include	<stdlib.h>
#include	<doslib.h>
#include <string.h>
#include "window.h"
#include "mime.h"
#include	"sub.h"
#include	"console.h"

typedef	struct{
	FILE	*rfp;
	FILE	*wfp;
	char	TargetFile[256];
	char	RenameFile[256];
}	MIMESET;

static int	winlist(SUBINF*, char*, int, int);
static int	openmime(MIMESET*, char*);
static int	closemime(MIMESET*, int);

static int
winlist(inf, wild, attr, offset)
SUBINF	*inf;
char	*wild;
int	attr;
int	offset;
{
	int	subwinmax = MEMBER_MAX;
	int	FoundFile;
	struct FILBUF	files_buffer;	/* files(fBNg)p */
	char	endflag = FALSE;

	while (!endflag) {
		inf->WinMax = offset;
		if (!alloc_subwin(inf, subwinmax)) {
			return FALSE;
		}
		FoundFile = FILES(&files_buffer, wild, attr);
		while (1) {		/* A */
			if (FoundFile < 0) {
				endflag = TRUE;
				break;
			}
			if (inf->WinMax >= subwinmax) {
				subwinmax *= 2;
				break;
			}
			if (strcmp(files_buffer.name, "." )
					&& strcmp(files_buffer.name, "..")) {
				strcpy(inf->WinMember[inf->WinMax++].name, files_buffer.name);
			}
		 	FoundFile = NFILES(&files_buffer);
		}
	}
	return TRUE;
}

static int
openmime(box, FileName)
MIMESET	*box;
char	*FileName;
{
	char	Temp[BUFMAX];

	/* ܂t@Cǂݏoɓŝ悢OɕςĂ܂ */
	strcpy(box->TargetFile, CDir);
	strcat(box->TargetFile, FileName);
	strcpy(box->RenameFile, CDir);
	strcat(box->RenameFile, "Temporary");

	if (rename(box->TargetFile, box->RenameFile) == -1) {
		StatusPut("MIME: [𕡎ʂł܂");
		return FALSE;
	}

	/* MIMEwb_̍ŌɈsǉ */
	if (!(box->rfp = fopen(box->RenameFile, "rt"))) {
		StatusPut("MIME: ꎞt@Cǂ߂܂");
		return FALSE;
	}
	
	if (!(box->wfp = fopen( box->TargetFile, "wt"))) {
		StatusPut("MIME: [쐬ł܂");
		fclose(box->rfp);
		return FALSE;
	}

	/* MIMEwb_̍ŌT */
	while (fgets822a(Temp, sizeof(Temp), box->rfp)) {
		fputs(Temp, box->wfp);
	}
	return TRUE;
}

static int
closemime(box, status)
MIMESET	*box;
int	status;
{
	char	Temp[256];

	if (status) {
		while (fgets(Temp, 256, box->rfp)) {
			fputs(Temp, box->wfp);
		}
	}
	fclose(box->rfp);
	fclose(box->wfp);

	/* ŌɃe| */
	if (remove(box->RenameFile) == -1) {
		StatusPut("ꎞt@C폜ł܂");
		return FALSE;
	}
	return TRUE;
}

/* t@CX-Attachmentsǉ */
int MimeManagerFree(char *FileName)
{
	MIMESET	mymime;
	char	Temp[256];

	if (!openmime(&mymime, FileName))	return FALSE;

	fputs("X-Attachment: \n\n", mymime.wfp);

	if (!closemime(&mymime, TRUE))	return FALSE;

	sprintf(Temp, "%s %s", Env.Med, mymime.TargetFile);
	childexec(Temp);

	return TRUE;
}

/* t@CX-Attachments+t@Cǉ */
int	MimeManagerBox(char *FileName)
{
	int Ret;
	MIMESET	mymime;
	SUBINF	inf;
	char	TargetDir[FILNMAX], Temp[BUFMAX];

	/* mimeboxfBNg(1Kw) */
	strcpy(Temp, Env.Mimebox);
	strcat(Temp, "*.*");
	if (!winlist(&inf, Temp, 0x10, 2))	return FALSE;
	strcpy(inf.WinMember[0].name, "蓮ݒ");
	strcpy(inf.WinMember[1].name, "./ c̃fBNg");

	Ret = WinManager(&inf, "   fBNg̑I", 0);
	strcpy(TargetDir, Env.Mimebox);
	if (Ret > 1) {
		/* TargetDir ɑIꂽfBNgZbg */
		strcat(TargetDir, inf.WinMember[Ret].name);
		strcat(TargetDir, "\\");
	}
	free_subwin(&inf);

	if (Ret < 0)	return FALSE;	/* LZ */
	if (!Ret)	return MimeManagerFree(FileName);

	/* t@C */
	strcpy(Temp, TargetDir);
	strcat(Temp, "*.*");
	if (!winlist( &inf, Temp, 0x20, 1)) {
		free_subwin(&inf);
		return FALSE;
	}

	strcpy(inf.WinMember[0].name, "IgȂ" );
	while (1) {
		Ret = WinManager(&inf, "   Ytt@C̑I", 1);
		if (Ret < 0) {
			free_subwin(&inf);
			return FALSE;	/* LZ */
		}
		/* 20ȏ̃}[N͑IׂȂ */
		if (inf.WinOnNum <= 20)	break;
		StatusPut("Ytł̂20܂łł");
	}
	if (!inf.WinOnNum) {
		if (Ret) {
			inf.WinOnNum = 1;
			inf.WinMember[Ret].On = TRUE;
		} else {
			free_subwin(&inf);
			return MimeManagerFree(FileName);
		}
	}
	if (!openmime(&mymime, FileName)) {
		free_subwin(&inf);
		return FALSE;	/* wȂ */
	} else {
		int	i, j;

		/* Yt(X-Attachment:)Zbg */
		for (i = 0, j = inf.WinOnNum; i < inf.WinMax; i++) {
			if (inf.WinMember[i].On) {
				fprintf(mymime.wfp, "X-Attachment: %s%s\n",
							TargetDir, inf.WinMember[i].name);
				if (!--j)	break;	/* Ō */
			}
		}
		fputc('\n', mymime.wfp);
	}
	free_subwin(&inf);

	return closemime(&mymime, TRUE);
}
